﻿using System.Collections.Generic;
using com.esendex.sdk.inbox;
using Microsoft.VisualStudio.TestTools.UnitTesting;

namespace com.esendex.sdk.test.inbox
{
    [TestClass]
    public class InboxMessagesTests
    {
        [TestMethod]
        public void InboxMessageCollection_DefaultDIConstructor()
        {
            //  Arrange            

            //  Act
            InboxMessageCollection collection = new InboxMessageCollection();

            //  Assert
            Assert.IsInstanceOfType(collection.Messages, typeof(List<InboxMessage>));
        }

        [TestMethod]
        public void InboxMessageCollection_SetPageNumber_WithZeroIndex_GetPageNumber_ReturnsPageNumber1()
        {
            // Arrange
            int startIndex = 0;
            int pageSize = 15;

            int expectedPageNumber = 1;

            InboxMessageCollection collection = new InboxMessageCollection()
            {
                PageSize = pageSize
            };

            // Act
            collection.PageNumber = startIndex;

            // Assert
            Assert.AreEqual(expectedPageNumber, collection.PageNumber);
        }

        [TestMethod]
        public void InboxMessageCollection_SetPageNumber_WithNonZeroIndex_GetPageNumber_ReturnsPageNumber()
        {
            // Arrange
            int startIndex = 30;
            int pageSize = 15;

            int expectedPageNumber = 3;

            InboxMessageCollection collection = new InboxMessageCollection()
            {
                PageSize = pageSize
            };

            // Act
            collection.PageNumber = startIndex;

            // Assert
            Assert.AreEqual(expectedPageNumber, collection.PageNumber);
        }
    }
}