﻿using System.Collections.Generic;
using com.esendex.sdk.sent;
using Microsoft.VisualStudio.TestTools.UnitTesting;

namespace com.esendex.sdk.test.sent
{
    [TestClass]
    public class SentMessageTests
    {
        [TestMethod]
        public void SentMessageCollection_DefaultDIConstructor()
        {
            //  Arrange            

            //  Act
            SentMessageCollection collection = new SentMessageCollection();

            //  Assert
            Assert.IsInstanceOfType(collection.Messages, typeof(List<SentMessage>));
        }

        [TestMethod]
        public void SentMessageCollection_SetPageNumber_WithZeroIndex_GetPageNumber_ReturnsPageNumber1()
        {
            // Arrange
            int startIndex = 0;
            int pageSize = 15;

            int expectedPageNumber = 1;

            SentMessageCollection collection = new SentMessageCollection()
            {
                PageSize = pageSize
            };             

            // Act
            collection.PageNumber = startIndex;
            
            // Assert
            Assert.AreEqual(expectedPageNumber, collection.PageNumber);
        }

        [TestMethod]
        public void SentMessageCollection_SetPageNumber_WithNonZeroIndex_GetPageNumber_ReturnsPageNumber()
        {
            // Arrange
            int startIndex = 30;
            int pageSize = 15;

            int expectedPageNumber = 3;

            SentMessageCollection collection = new SentMessageCollection()
            {
                PageSize = pageSize
            };

            // Act
            collection.PageNumber = startIndex;

            // Assert
            Assert.AreEqual(expectedPageNumber, collection.PageNumber);
        }
    }
}
